<?php
 
 
 

namespace Google\Protobuf\Internal;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBWire;
use Google\Protobuf\Internal\InputStream;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;






class FileDescriptorProto extends \Google\Protobuf\Internal\Message
{
    




    protected $name = null;
    




    protected $package = null;
    




    private $dependency;
    




    private $public_dependency;
    





    private $weak_dependency;
    





    private $option_dependency;
    




    private $message_type;
    


    private $enum_type;
    


    private $service;
    


    private $extension;
    


    protected $options = null;
    







    protected $source_code_info = null;
    









    protected $syntax = null;
    







    protected $edition = null;

    












































    public function __construct($data = NULL) {
        \GPBMetadata\Google\Protobuf\Internal\Descriptor::initOnce();
        parent::__construct($data);
    }

    





    public function getName()
    {
        return isset($this->name) ? $this->name : '';
    }

    public function hasName()
    {
        return isset($this->name);
    }

    public function clearName()
    {
        unset($this->name);
    }

    






    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    





    public function getPackage()
    {
        return isset($this->package) ? $this->package : '';
    }

    public function hasPackage()
    {
        return isset($this->package);
    }

    public function clearPackage()
    {
        unset($this->package);
    }

    






    public function setPackage($var)
    {
        GPBUtil::checkString($var, True);
        $this->package = $var;

        return $this;
    }

    





    public function getDependency()
    {
        return $this->dependency;
    }

    






    public function setDependency($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->dependency = $arr;

        return $this;
    }

    





    public function getPublicDependency()
    {
        return $this->public_dependency;
    }

    






    public function setPublicDependency($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::INT32);
        $this->public_dependency = $arr;

        return $this;
    }

    






    public function getWeakDependency()
    {
        return $this->weak_dependency;
    }

    







    public function setWeakDependency($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::INT32);
        $this->weak_dependency = $arr;

        return $this;
    }

    






    public function getOptionDependency()
    {
        return $this->option_dependency;
    }

    







    public function setOptionDependency($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->option_dependency = $arr;

        return $this;
    }

    





    public function getMessageType()
    {
        return $this->message_type;
    }

    






    public function setMessageType($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Protobuf\Internal\DescriptorProto::class);
        $this->message_type = $arr;

        return $this;
    }

    



    public function getEnumType()
    {
        return $this->enum_type;
    }

    




    public function setEnumType($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Protobuf\Internal\EnumDescriptorProto::class);
        $this->enum_type = $arr;

        return $this;
    }

    



    public function getService()
    {
        return $this->service;
    }

    




    public function setService($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Protobuf\Internal\ServiceDescriptorProto::class);
        $this->service = $arr;

        return $this;
    }

    



    public function getExtension()
    {
        return $this->extension;
    }

    




    public function setExtension($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Protobuf\Internal\FieldDescriptorProto::class);
        $this->extension = $arr;

        return $this;
    }

    



    public function getOptions()
    {
        return $this->options;
    }

    public function hasOptions()
    {
        return isset($this->options);
    }

    public function clearOptions()
    {
        unset($this->options);
    }

    




    public function setOptions($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Internal\FileOptions::class);
        $this->options = $var;

        return $this;
    }

    








    public function getSourceCodeInfo()
    {
        return $this->source_code_info;
    }

    public function hasSourceCodeInfo()
    {
        return isset($this->source_code_info);
    }

    public function clearSourceCodeInfo()
    {
        unset($this->source_code_info);
    }

    









    public function setSourceCodeInfo($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Internal\SourceCodeInfo::class);
        $this->source_code_info = $var;

        return $this;
    }

    










    public function getSyntax()
    {
        return isset($this->syntax) ? $this->syntax : '';
    }

    public function hasSyntax()
    {
        return isset($this->syntax);
    }

    public function clearSyntax()
    {
        unset($this->syntax);
    }

    











    public function setSyntax($var)
    {
        GPBUtil::checkString($var, True);
        $this->syntax = $var;

        return $this;
    }

    








    public function getEdition()
    {
        return isset($this->edition) ? $this->edition : 0;
    }

    public function hasEdition()
    {
        return isset($this->edition);
    }

    public function clearEdition()
    {
        unset($this->edition);
    }

    









    public function setEdition($var)
    {
        GPBUtil::checkEnum($var, \Google\Protobuf\Internal\Edition::class);
        $this->edition = $var;

        return $this;
    }

}

